'use strict';

var util = require('util');
var Undertaker = require('undertaker');
var vfs = require('vinyl-fs');

function Gulp() {
  Undertaker.call(this);
}
util.inherits(Gulp, Undertaker);

Gulp.prototype.src = vfs.src;
Gulp.prototype.dest = vfs.dest;
Gulp.prototype.watch = function(glob, opt, task) {
  var isFunction = (typeof opt === 'function');
  var isString = (typeof opt === 'string');
  var isArray = Array.isArray(opt);
  if (isFunction || isString || isArray) {
    task = opt;
    opt = null;
  }

  var fn;
  if (task) {
    fn = this.parallel(task);
  }

  return vfs.watch(glob, opt, fn);
};

// Let people use this class from our instance
Gulp.prototype.Gulp = Gulp;

var inst = new Gulp();
module.exports = inst;
